/**
 * Exposes common HTTP errors with a preconfigured `statusCode` for convenience.
 * This does not mean you have to use HTTP to use them, it's just that
 * HTTP has already defined a nice set of common error types, and tacking
 * on the HTTP status code makes it easier to consume in HTTP apps.
 */
import { BaseErrorConstructor } from './make-error-class';
declare const BadRequest_base: HttpErrorConstructor;
/** *********************************************
 * List of all CLIENT Errors (4xx)
 */
/**
 * Creates a `BadRequest` error.
 */
export declare class BadRequest extends BadRequest_base {
}
declare const NotAuthenticated_base: HttpErrorConstructor;
/**
 * Creates a `NotAuthenticated` error.
 */
export declare class NotAuthenticated extends NotAuthenticated_base {
}
declare const PaymentRequired_base: HttpErrorConstructor;
/**
 * Creates a `PaymentRequired` error.
 */
export declare class PaymentRequired extends PaymentRequired_base {
}
declare const Forbidden_base: HttpErrorConstructor;
/**
 * Creates a `Forbidden` error.
 */
export declare class Forbidden extends Forbidden_base {
}
declare const NotFound_base: HttpErrorConstructor;
/**
 * Creates a `NotFound` error.
 */
export declare class NotFound extends NotFound_base {
}
declare const MethodNotAllowed_base: HttpErrorConstructor;
/**
 * Creates a `MethodNotAllowed` error.
 */
export declare class MethodNotAllowed extends MethodNotAllowed_base {
}
declare const NotAcceptable_base: HttpErrorConstructor;
/**
 * Creates a `NotAcceptable` error.
 */
export declare class NotAcceptable extends NotAcceptable_base {
}
declare const ProxyAuthenticationRequired_base: HttpErrorConstructor;
/**
 * Creates a `ProxyAuthenticationRequired` error.
 */
export declare class ProxyAuthenticationRequired extends ProxyAuthenticationRequired_base {
}
declare const Timeout_base: HttpErrorConstructor;
/**
 * Creates a `Timeout` error.
 */
export declare class Timeout extends Timeout_base {
}
declare const Conflict_base: HttpErrorConstructor;
/**
 * Creates a `Conflict` error.
 */
export declare class Conflict extends Conflict_base {
}
declare const Gone_base: HttpErrorConstructor;
/**
 * Creates a `Gone` error.
 */
export declare class Gone extends Gone_base {
}
declare const LengthRequired_base: HttpErrorConstructor;
/**
 * Creates a `LengthRequired` error.
 */
export declare class LengthRequired extends LengthRequired_base {
}
declare const PreconditionFailed_base: HttpErrorConstructor;
/**
 * Creates a `PreconditionFailed` error.
 */
export declare class PreconditionFailed extends PreconditionFailed_base {
}
declare const PayloadTooLarge_base: HttpErrorConstructor;
/**
 * Creates a `PayloadTooLarge` error.
 */
export declare class PayloadTooLarge extends PayloadTooLarge_base {
}
declare const UriTooLong_base: HttpErrorConstructor;
/**
 * Creates a `UriTooLong` error.
 */
export declare class UriTooLong extends UriTooLong_base {
}
declare const UnsupportedMediaType_base: HttpErrorConstructor;
/**
 * Creates a `UnsupportedMediaType` error.
 */
export declare class UnsupportedMediaType extends UnsupportedMediaType_base {
}
declare const RequestRangeNotSatisfiable_base: HttpErrorConstructor;
/**
 * Creates a `RequestRangeNotSatisfiable` error.
 */
export declare class RequestRangeNotSatisfiable extends RequestRangeNotSatisfiable_base {
}
declare const ExpectationFailed_base: HttpErrorConstructor;
/**
 * Creates a `ExpectationFailed` error.
 */
export declare class ExpectationFailed extends ExpectationFailed_base {
}
declare const IAmATeapot_base: HttpErrorConstructor;
/**
 * Creates a `IAmATeapot` error.
 */
export declare class IAmATeapot extends IAmATeapot_base {
}
declare const MisdirectedRequest_base: HttpErrorConstructor;
/**
 * Creates a `MisdirectedRequest` error.
 */
export declare class MisdirectedRequest extends MisdirectedRequest_base {
}
declare const Unprocessable_base: HttpErrorConstructor;
/**
 * Creates a `Unprocessable` error.
 */
export declare class Unprocessable extends Unprocessable_base {
}
declare const Locked_base: HttpErrorConstructor;
/**
 * Creates a `Locked` error.
 */
export declare class Locked extends Locked_base {
}
declare const FailedDependency_base: HttpErrorConstructor;
/**
 * Creates a `FailedDependency` error.
 */
export declare class FailedDependency extends FailedDependency_base {
}
declare const TooEarly_base: HttpErrorConstructor;
/**
 * Creates a `TooEarly` error.
 */
export declare class TooEarly extends TooEarly_base {
}
declare const UpgradeRequired_base: HttpErrorConstructor;
/**
 * Creates a `UpgradeRequired` error.
 */
export declare class UpgradeRequired extends UpgradeRequired_base {
}
declare const PreconditionRequired_base: HttpErrorConstructor;
/**
 * Creates a `PreconditionRequired` error.
 */
export declare class PreconditionRequired extends PreconditionRequired_base {
}
declare const TooManyRequests_base: HttpErrorConstructor;
/**
 * Creates a `TooManyRequests` error.
 */
export declare class TooManyRequests extends TooManyRequests_base {
}
declare const RequestHeaderFieldsTooLarge_base: HttpErrorConstructor;
/**
 * Creates a `RequestHeaderFieldsTooLarge` error.
 */
export declare class RequestHeaderFieldsTooLarge extends RequestHeaderFieldsTooLarge_base {
}
declare const UnavailableForLegalReasons_base: HttpErrorConstructor;
/**
 * Creates a `UnavailableForLegalReasons` error.
 */
export declare class UnavailableForLegalReasons extends UnavailableForLegalReasons_base {
}
declare const GeneralError_base: HttpErrorConstructor;
/** *********************************************
 * List of all SERVER Errors (5xx)
 */
/**
 * Creates a `GeneralError` error.
 * This is basically some kind of `InternalServerError` error.
 */
export declare class GeneralError extends GeneralError_base {
}
declare const NotImplemented_base: HttpErrorConstructor;
/**
 * Creates a `NotImplemented` error.
 */
export declare class NotImplemented extends NotImplemented_base {
}
declare const BadGateway_base: HttpErrorConstructor;
/**
 * Creates a `BadGateway` error.
 */
export declare class BadGateway extends BadGateway_base {
}
declare const ServiceUnavailable_base: HttpErrorConstructor;
/**
 * Creates a `ServiceUnavailable` error.
 */
export declare class ServiceUnavailable extends ServiceUnavailable_base {
}
declare const GatewayTimeout_base: HttpErrorConstructor;
/**
 * Creates a `GatewayTimeout` error.
 */
export declare class GatewayTimeout extends GatewayTimeout_base {
}
declare const HttpVersionNotSupported_base: HttpErrorConstructor;
/**
 * Creates a `HttpVersionNotSupported` error.
 */
export declare class HttpVersionNotSupported extends HttpVersionNotSupported_base {
}
declare const VariantAlsoNegotiates_base: HttpErrorConstructor;
/**
 * Creates a `VariantAlsoNegotiates` error.
 */
export declare class VariantAlsoNegotiates extends VariantAlsoNegotiates_base {
}
declare const InsufficientStorage_base: HttpErrorConstructor;
/**
 * Creates a `InsufficientStorage` error.
 */
export declare class InsufficientStorage extends InsufficientStorage_base {
}
declare const LoopDetected_base: HttpErrorConstructor;
/**
 * Creates a `LoopDetected` error.
 */
export declare class LoopDetected extends LoopDetected_base {
}
declare const NotExtended_base: HttpErrorConstructor;
/**
 * Creates a `NotExtended` error.
 */
export declare class NotExtended extends NotExtended_base {
}
declare const NetworkAuthenticationRequired_base: HttpErrorConstructor;
/**
 * Creates a `NetworkAuthenticationRequired` error.
 */
export declare class NetworkAuthenticationRequired extends NetworkAuthenticationRequired_base {
}
/**
 * HTTP error constructor.
 */
export declare type HttpErrorConstructor = BaseErrorConstructor<{
    statusCode: number;
}>;
/**
 * Gets an error constructor for a HTTP status code.
 *
 * @param statusCode
 */
export declare function getHttpErrorConstructorForStatusCode(statusCode: number): HttpErrorConstructor;
export {};
