/**
 * Type for the ignore func.
 */
export declare type IgnoreFunc<T> = (err: any) => T | never;
/**
 * Utility for ignoring certain errors and returning a default value.
 *
 * @param errorClasses
 */
export declare function ignore<T>(...errorClasses: Array<new () => Error>): (valToReturnOnCatch: T) => IgnoreFunc<T>;
